> ## Documentation Index
> Fetch the complete documentation index at: https://www.latitude.sh/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Create volume

> Allows you to add persistent storage to a project. These volumes can be used to store data across your servers.



## OpenAPI

````yaml https://spec.speakeasy.com/latitude/latitude/latitude-sh-api-with-code-samples post /storage/volumes
openapi: 3.0.1
info:
  title: Latitude.sh API
  version: '2023-06-01'
  description: >-
    The Latitude.sh API is a RESTful API to manage your Latitude.sh account. It
    allows you to perform the same actions as the Latitude.sh dashboard.
servers:
  - url: https://api.latitude.sh
    variables:
      latitude_api_key:
        default: <insert your api key here>
  - url: http://api.latitude.sh
    variables:
      latitude_api_key:
        default: <insert your api key here>
security: []
tags:
  - name: API keys
  - name: Billing
  - name: Elastic Ips
  - name: Events
  - name: Firewalls
  - name: IP Addresses
  - name: Kubernetes Clusters
  - name: Operating Systems
  - name: Plans
  - name: Private Networks
  - name: Projects
  - name: Regions
  - name: Roles
  - name: SSH Keys
  - name: Servers
  - name: Storage
  - name: Tags
  - name: Teams
  - name: Team members
  - name: Traffic
  - name: User data
  - name: User profile
  - name: VPN Sessions
  - name: Virtual machines
paths:
  /storage/volumes:
    post:
      tags:
        - Storage
      summary: Create volume
      description: >-
        Allows you to add persistent storage to a project. These volumes can be
        used to store data across your servers.
      operationId: post-storage-volumes
      parameters: []
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                data:
                  type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - volumes
                    attributes:
                      type: object
                      properties:
                        project:
                          type: string
                          description: Project ID or slug
                        name:
                          type: string
                          description: Storage name
                        size_in_gb:
                          type: integer
                          default: 1500
                          minimum: 1
                          maximum: 10000
                          description: Size in GB (not required, default is 1500)
                      required:
                        - project
                        - name
                  required:
                    - type
                    - attributes
              required:
                - data
            examples:
              Created:
                summary: Created
                value:
                  data:
                    type: volumes
                    attributes:
                      name: my-data
                      size_in_gb: 1500
                      project: proj_enPbqoZ6dA2MQ
          application/vnd.api+json:
            schema:
              type: object
              properties:
                data:
                  type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - volumes
                    attributes:
                      type: object
                      properties:
                        project:
                          type: string
                          description: Project ID or slug
                        name:
                          type: string
                          description: Storage name
                        size_in_gb:
                          type: integer
                          default: 1500
                          minimum: 1
                          maximum: 10000
                          description: Size in GB (not required, default is 1500)
                      required:
                        - project
                        - name
                  required:
                    - type
                    - attributes
              required:
                - data
            examples:
              Created:
                summary: Created
                value:
                  data:
                    type: volumes
                    attributes:
                      name: my-data
                      size_in_gb: 1500
                      project: proj_enPbqoZ6dA2MQ
        required: true
      responses:
        '201':
          description: Created
          content:
            application/vnd.api+json:
              examples:
                Created:
                  value:
                    data:
                      id: vol_Av9BVDavORm1W
                      type: volumes
                      attributes:
                        name: Rustic Aluminum Shoes
                        size_in_gb: 1500
                        created_at: '2026-01-14T15:57:08.000Z'
                        namespace_id: null
                        connector_id: null
                        initiators: null
                        project:
                          id: proj_enPbqoZ6dA2MQ
                          name: Mediocre Aluminum Car
                          slug: mediocre-aluminum-car
                          description: Rustic Linen Shoes
                          billing_type: Normal
                          billing_method: Normal
                          bandwidth_alert: false
                          environment: null
                          billing:
                            subscription_id: null
                            type: Normal
                            method: Normal
                          stats:
                            databases: 0
                            ip_addresses: 0
                            prefixes: 0
                            servers: 0
                            storages: 1
                            virtual_machines: 0
                            vlans: 0
                        team:
                          id: team_geEQyBL2bJiVpXJgmw1YTgneKVb
                          name: 609 Team
                          slug: 609-team
                          description: 609 Team
                          address: Apt. 590 415 Kirlin Pass, South Trenton, MT 96944
                          status: verified
                          currency:
                            id: cur_AW6Q2D9lqKLpr
                            code: BRL
                            name: Brazilian Real
                            currency_id: null
              schema:
                type: object
                properties:
                  data:
                    $ref: '#/components/schemas/volume_data'
        '503':
          description: Service Unavailable - Storage creation temporarily frozen
          content:
            application/vnd.api+json:
              examples:
                Storage creation frozen:
                  value:
                    errors:
                      - code: STORAGE_CREATION_FROZEN
                        status: '503'
                        title: Storage creation frozen
                        detail: New volume creation is temporarily unavailable.
                        meta: {}
              schema:
                $ref: '#/components/schemas/error_object'
      security:
        - Bearer: []
      x-codeSamples:
        - lang: python
          label: Python (SDK)
          source: |-
            import latitudesh_python_sdk
            from latitudesh_python_sdk import Latitudesh
            import os


            with Latitudesh(
                bearer=os.getenv("LATITUDESH_BEARER", ""),
            ) as latitudesh:

                res = latitudesh.storage.post_storage_volumes(data={
                    "type": latitudesh_python_sdk.PostStorageVolumesStorageType.VOLUMES,
                    "attributes": {
                        "project": "proj_enPbqoZ6dA2MQ",
                        "name": "my-data",
                    },
                })

                # Handle response
                print(res)
        - lang: go
          label: Go (SDK)
          source: "package main\n\nimport(\n\t\"context\"\n\t\"os\"\n\tlatitudeshgosdk \"github.com/latitudesh/latitudesh-go-sdk\"\n\t\"github.com/latitudesh/latitudesh-go-sdk/models/operations\"\n\t\"log\"\n)\n\nfunc main() {\n    ctx := context.Background()\n\n    s := latitudeshgosdk.New(\n        latitudeshgosdk.WithSecurity(os.Getenv(\"LATITUDESH_BEARER\")),\n    )\n\n    res, err := s.Storage.PostStorageVolumes(ctx, operations.PostStorageVolumesStorageRequestBody{\n        Data: operations.PostStorageVolumesStorageData{\n            Type: operations.PostStorageVolumesStorageTypeVolumes,\n            Attributes: operations.PostStorageVolumesStorageAttributes{\n                Project: \"proj_enPbqoZ6dA2MQ\",\n                Name: \"my-data\",\n            },\n        },\n    })\n    if err != nil {\n        log.Fatal(err)\n    }\n    if res.Object != nil {\n        // handle response\n    }\n}"
        - lang: typescript
          label: Typescript (SDK)
          source: |-
            import { Latitudesh } from "latitudesh-typescript-sdk";

            const latitudesh = new Latitudesh({
              bearer: process.env["LATITUDESH_BEARER"] ?? "",
            });

            async function run() {
              const result = await latitudesh.storage.postStorageVolumes({
                data: {
                  type: "volumes",
                  attributes: {
                    project: "proj_enPbqoZ6dA2MQ",
                    name: "my-data",
                  },
                },
              });

              console.log(result);
            }

            run();
components:
  schemas:
    volume_data:
      type: object
      properties:
        id:
          type: string
        type:
          type: string
          enum:
            - volumes
        attributes:
          type: object
          properties:
            name:
              type: string
            size_in_gb:
              type: integer
            created_at:
              type: string
              format: date-time
              nullable: true
            namespace_id:
              type: string
              nullable: true
            connector_id:
              type: string
              nullable: true
            initiators:
              type: array
              items:
                type: object
                properties:
                  nqn:
                    type: string
              nullable: true
            project:
              $ref: '#/components/schemas/project_include'
            team:
              $ref: '#/components/schemas/team_include'
    error_object:
      type: object
      properties:
        errors:
          type: array
          items:
            type: object
            properties:
              code:
                type: string
                nullable: true
              status:
                type: string
              title:
                type: string
              detail:
                type: string
              source:
                type: object
                properties:
                  pointer:
                    type: string
                  parameter:
                    type: string
              meta:
                type: object
    project_include:
      type: object
      properties:
        id:
          type: string
        name:
          type: string
        slug:
          type: string
        description:
          type: string
          nullable: true
        billing_type:
          type: string
          nullable: true
        provisioning_type:
          type: string
          nullable: true
        billing_method:
          type: string
          nullable: true
        bandwidth_alert:
          type: boolean
        environment:
          type: string
          nullable: true
        billing:
          type: object
          properties:
            subscription_id:
              type: string
              nullable: true
            type:
              type: string
            method:
              type: string
        stats:
          type: object
          properties:
            ip_addresses:
              type: integer
            prefixes:
              type: integer
            servers:
              type: integer
            vlans:
              type: integer
    team_include:
      type: object
      properties:
        id:
          type: string
        name:
          type: string
        slug:
          type: string
        description:
          type: string
          nullable: true
        address:
          type: string
        currency:
          type: object
        status:
          type: string
        feature_flags:
          type: array
          items:
            type: string
  securitySchemes:
    Bearer:
      type: apiKey
      name: Authorization
      in: header

````